﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
Sub Process_Globals
	Private fx As JFX
	Private xui As XUI
End Sub

Public Sub add_new_label
	Main.panepressed = False
	Dim td As tagdata
	td.PressedX = 0
	td.PressedY = 0
	td.count = Main.nodecnt
	td.id = "Label" & Main.nodecnt
	Dim newlbl As Label
	newlbl.Initialize("lbl")
	newlbl.SetSize(100,50)
	newlbl.Top = 20		' top left corner	'panemain.Height - 60 => bottom left corner
	newlbl.Left = 20
	newlbl.Text = "Label" & Main.nodecnt
	newlbl.Id = "Label" & Main.nodecnt
	newlbl.Font = fx.CreateFont("Verdana",15,False,False)
	newlbl.Alignment = "TOP_LEFT"
	newlbl.WrapText = True
	CSSUtils.SetBorder(newlbl,2,fx.Colors.Black,5)
	Dim red As Int = Rnd(150,250)
	Dim green As Int = Rnd(150,250)
	Dim blue As Int = Rnd(150,250)
	CSSUtils.SetBackgroundColor(newlbl, fx.Colors.ARGB(255,red,green,blue))
	td.brdthick = 2
	td.brdcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.brdradius = 5
	td.backcolor = xui.PaintOrColorToColor(fx.Colors.ARGB(255,red,green,blue))
	td.noborder = False
	td.fontfamily = "Verdana"
	td.fontsize = 15
	td.isbold = "false"
	td.isitalic = "false"
	td.alignment = "TOP_LEFT"
	td.textcolor = xui.PaintOrColorToColor(fx.Colors.Black)
	td.imgurl = ""
	newlbl.Tag = td
	Main.panemain.AddNode(newlbl,newlbl.Left,newlbl.top,newlbl.prefWidth,newlbl.PrefHeight)
	Main.nodecnt = Main.nodecnt + 1
End Sub

Public Sub resize_label(ParentX As Double, ParentY As Double)
	Dim gap As Int = 5
	Dim minwidth As Int = Main.edgewidth * 4
	Dim minheight As Int = Main.edgewidth * 4
	If Main.resizing = True Then
		If Main.lxpos > 0 And Main.lypos > 0 Then
			If Main.xpress <= Main.edgewidth Then	' left edge
				If Main.lxpos > ParentX Then	' moving left
					If Main.currlabel.Left - gap > 0 Then
						Main.currlabel.Left = Main.currlabel.Left - gap
						Main.currlabel.prefWidth = Main.currlabel.Width + gap
					End If
				Else	' moving right
					If Main.currlabel.Width - gap > minwidth Then
						Main.currlabel.Left = Main.currlabel.Left + gap
						Main.currlabel.prefWidth = Main.currlabel.Width - gap
					End If
				End If
			End If
			If Main.xpress >= (Main.currlabel.Width - Main.edgewidth) And Main.xpress < Main.currlabel.Width Then	' right edge
				If Main.lxpos > ParentX Then	' moving left
					If Main.currlabel.Width > minwidth Then
						Main.currlabel.prefWidth = Main.currlabel.Width - gap
						Main.xpress = Main.xpress - gap
					End If
				Else	' moving right
					If Main.currlabel.Width + Main.currlabel.Left < Main.panemain.Width Then
						Main.currlabel.prefWidth = Main.currlabel.Width + gap
						Main.xpress = Main.xpress + gap
					End If
				End If
			End If
			If Main.ypress <= Main.edgewidth Then	'top edge
				If Main.lypos > ParentY Then	' moving up
					If Main.currlabel.Top - gap > 0 Then
						Main.currlabel.Top = Main.currlabel.Top - gap
						Main.currlabel.prefHeight = Main.currlabel.Height + gap
					End If
				Else	' moving down
					If Main.currlabel.Height - gap > minheight Then
						Main.currlabel.Top = Main.currlabel.Top + gap
						Main.currlabel.PrefHeight = Main.currlabel.Height - gap
					End If
				End If
			End If
			If Main.ypress >= (Main.currlabel.Height - Main.edgewidth) And Main.ypress < Main.currlabel.Height Then	' bottom edge
				If Main.lypos > ParentY Then	' moving up
					If Main.currlabel.Height > minheight Then
						Main.currlabel.prefHeight = Main.currlabel.Height - gap
						Main.ypress = Main.ypress - gap
					End If
				Else	'moving down
					If Main.currlabel.Height + Main.currlabel.Top < Main.panemain.Height Then
						Main.currlabel.prefHeight = Main.currlabel.Height + gap
						Main.ypress = Main.ypress + gap
					End If
				End If
			End If
		End If
	End If
End Sub

Public Sub load_label(td As tagdata,valuesmap As Map)
	Dim newlbl As Label
	newlbl.Initialize("lbl")
	newlbl.Top = valuesmap.Get("top")
	newlbl.Left = valuesmap.Get("left")
	newlbl.prefwidth = valuesmap.Get("width")
	newlbl.prefheight = valuesmap.Get("height")
	Dim strtxt As String = valuesmap.Get("text")
	strtxt = strtxt.Replace("&lf;",Chr(10))
	strtxt = strtxt.Replace("&quote;","""")
	strtxt = strtxt.Replace("&comma;",",")
	newlbl.Text = strtxt
	newlbl.Tag = td
	newlbl.Id = td.id
	newlbl.WrapText = True
	newlbl.TextColor = fx.Colors.From32Bit(td.textcolor)
	CSSUtils.SetStyleProperty(newlbl,"-fx-font-family",td.fontfamily)
	CSSUtils.SetStyleProperty(newlbl,"-fx-font-size",td.fontsize)
	If td.isitalic = "true" Then
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-style","italic")
	Else
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-style","normal")
	End If
	If td.isbold = "true" Then
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-weight","bold")
	Else
		CSSUtils.SetStyleProperty(newlbl,"-fx-font-weight","normal")
	End If
	newlbl.Alignment = td.alignment
	CSSUtils.SetBorder(newlbl,td.brdthick,fx.Colors.From32Bit(td.brdcolor),td.brdradius)
	CSSUtils.SetBackgroundColor(newlbl, fx.Colors.From32Bit(td.backcolor))
	If td.imgurl <> "" Then
		Dim folder As String = td.imgurl.SubString2(0,td.imgurl.LastIndexOf("/"))
		Dim fname As String = td.imgurl.SubString(td.imgurl.LastIndexOf("/")+1)
		CSSUtils.SetBackgroundImage(newlbl,folder,fname)
	End If
	Main.panemain.AddNode(newlbl,newlbl.Left,newlbl.Top,newlbl.prefWidth,newlbl.prefHeight)
End Sub

Private Sub lbl_MouseClicked(EventData As MouseEvent)
	Dim view As Label = Sender
	Log(view.Tag)
	Main.currlabel = view
	Main.show_component_info(view)
	Main.currnode = view
End Sub
Private Sub lbl_MouseDragged (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	Dim ParentX As Int = EventData.X + view.Left
	Dim ParentY As Int = EventData.Y + view.Top
	If Main.resizing = False Then
		view.Left = ParentX - td.PressedX
		view.Top = ParentY - td.PressedY
		If view.Left < 0 Then view.Left = 0
		If view.Top < 0 Then view.Top = 0
		If view.Left + view.Width > Main.panemain.Width Then view.Left = Main.panemain.Width - view.Width
		If view.top + view.Height > Main.panemain.Height Then view.top = Main.panemain.Height - view.Height
	Else
		view.As(Label).MouseCursor = fx.Cursors.CLOSED_HAND
		CSSUtils.SetBorder(view,10,fx.Colors.Blue,0)
	End If
	Main.currlabel = view
	Main.currnode = view
End Sub
Private Sub lbl_MouseEntered (EventData As MouseEvent)
End Sub
Private Sub lbl_MouseExited (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	view.As(Label).MouseCursor = fx.Cursors.MOVE
	Main.set_border(view)
End Sub
Private Sub lbl_MousePressed (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	td.PressedX = EventData.X
	td.PressedY = EventData.Y
	view.Tag = td
	Main.xpress = EventData.X
	Main.ypress = EventData.Y
	If td.PressedX <= Main.edgewidth Or td.PressedX >= view.Width - Main.edgewidth  Then Main.resizing = True
	If td.PressedY <= Main.edgewidth Or td.PressedY >= view.Height - Main.edgewidth  Then Main.resizing = True
	Main.lxpos = td.PressedX + view.Left
	Main.lypos = td.PressedY + view.Top
End Sub
Private Sub lbl_MouseReleased (EventData As MouseEvent)
	Main.panepressed = False
	Main.resizing = False
	Main.snap_to_grid
End Sub
Private Sub lbl_MouseMoved (EventData As MouseEvent)
	Main.panepressed = False
	Dim view As B4XView = Sender
	Dim td As tagdata = view.Tag
	If td.id.Contains("Pane") Then Return
	Dim rightsizing As Int = view.Width - Main.edgewidth
	Dim downsizing As Int = view.Height - Main.edgewidth
	Dim leftsizing As Int = Main.edgewidth
	Dim topsizing As Int = Main.edgewidth
	If EventData.X > rightsizing Or EventData.Y > downsizing Or EventData.X < leftsizing Or EventData.Y < topsizing Then
		view.As(Label).MouseCursor = fx.Cursors.OPEN_HAND
		CSSUtils.SetBorder(view,10,fx.Colors.Blue,0)
	Else
		view.As(Label).MouseCursor = fx.Cursors.MOVE
		Main.set_border(view)
	End If
End Sub
